diff --git a/src/test/perl/PostgresNode.pm b/src/test/perl/Postgres/Test/Cluster.pm
similarity index 92%
rename from src/test/perl/PostgresNode.pm
rename to src/test/perl/Postgres/Test/Cluster.pm
index c59da758c7..44621f3b4f 100644
--- a/src/test/perl/PostgresNode.pm
+++ b/src/test/perl/Postgres/Test/Cluster.pm
@@ -5,13 +5,13 @@
 
 =head1 NAME
 
-PostgresNode - class representing PostgreSQL server instance
+Postgres::Test::Cluster - class representing PostgreSQL server instance
 
 =head1 SYNOPSIS
 
-  use PostgresNode;
+  use Postgres::Test::Cluster;
 
-  my $node = PostgresNode->new('mynode');
+  my $node = Postgres::Test::Cluster->new('mynode');
 
   # Create a data directory with initdb
   $node->init();
@@ -61,7 +61,7 @@ PostgresNode - class representing PostgreSQL server instance
   my $ret = $node->backup_fs_cold('testbackup3')
 
   # Restore it to create a new independent node (not a replica)
-  my $other_node = PostgresNode->new('mycopy');
+  my $other_node = Postgres::Test::Cluster->new('mycopy');
   $other_node->init_from_backup($node, 'testbackup');
   $other_node->start;
 
@@ -69,15 +69,15 @@ PostgresNode - class representing PostgreSQL server instance
   $node->stop('fast');
 
   # Find a free, unprivileged TCP port to bind some other service to
-  my $port = PostgresNode::get_free_port();
+  my $port = Postgres::Test::Cluster::get_free_port();
 
 =head1 DESCRIPTION
 
-PostgresNode contains a set of routines able to work on a PostgreSQL node,
+Postgres::Test::Cluster contains a set of routines able to work on a PostgreSQL node,
 allowing to start, stop, backup and initialize it with various options.
 The set of nodes managed by a given test is also managed by this module.
 
-In addition to node management, PostgresNode instances have some wrappers
+In addition to node management, Postgres::Test::Cluster instances have some wrappers
 around Test::More functions to run commands with an environment set up to
 point to the instance.
 
@@ -85,7 +85,7 @@ The IPC::Run module is required.
 
 =cut
 
-package PostgresNode;
+package Postgres::Test::Cluster;
 
 use strict;
 use warnings;
@@ -100,11 +100,11 @@ use File::Spec;
 use File::stat qw(stat);
 use File::Temp ();
 use IPC::Run;
-use PostgresVersion;
-use RecursiveCopy;
+use Postgres::Test::PostgresVersion;
+use Postgres::Test::RecursiveCopy;
 use Socket;
 use Test::More;
-use TestLib ();
+use Postgres::Test::Utils ();
 use Time::HiRes qw(usleep);
 use Scalar::Util qw(blessed);
 
@@ -116,10 +116,10 @@ INIT
 
 	# Set PGHOST for backward compatibility.  This doesn't work for own_host
 	# nodes, so prefer to not rely on this when writing new tests.
-	$use_tcp            = !$TestLib::use_unix_sockets;
+	$use_tcp            = !$Postgres::Test::Utils::use_unix_sockets;
 	$test_localhost     = "127.0.0.1";
 	$last_host_assigned = 1;
-	$test_pghost        = $use_tcp ? $test_localhost : TestLib::tempdir_short;
+	$test_pghost        = $use_tcp ? $test_localhost : Postgres::Test::Utils::tempdir_short;
 	$ENV{PGHOST}        = $test_pghost;
 	$ENV{PGDATABASE}    = 'postgres';
 
@@ -369,8 +369,8 @@ sub set_replication_conf
 	  or croak "set_replication_conf only works with the default host";
 
 	open my $hba, '>>', "$pgdata/pg_hba.conf";
-	print $hba "\n# Allow replication (set up by PostgresNode.pm)\n";
-	if ($TestLib::windows_os && !$TestLib::use_unix_sockets)
+	print $hba "\n# Allow replication (set up by Postgres::Test::Cluster.pm)\n";
+	if ($Postgres::Test::Utils::windows_os && !$Postgres::Test::Utils::use_unix_sockets)
 	{
 		print $hba
 		  "host replication all $test_localhost/32 sspi include_realm=1 map=regress\n";
@@ -419,13 +419,13 @@ sub init
 	mkdir $self->backup_dir;
 	mkdir $self->archive_dir;
 
-	TestLib::system_or_bail('initdb', '-D', $pgdata, '-A', 'trust', '-N',
+	Postgres::Test::Utils::system_or_bail('initdb', '-D', $pgdata, '-A', 'trust', '-N',
 		@{ $params{extra} });
-	TestLib::system_or_bail($ENV{PG_REGRESS}, '--config-auth', $pgdata,
+	Postgres::Test::Utils::system_or_bail($ENV{PG_REGRESS}, '--config-auth', $pgdata,
 		@{ $params{auth_extra} });
 
 	open my $conf, '>>', "$pgdata/postgresql.conf";
-	print $conf "\n# Added by PostgresNode.pm\n";
+	print $conf "\n# Added by Postgres::Test::Cluster.pm\n";
 	print $conf "fsync = off\n";
 	print $conf "restart_after_crash = off\n";
 	print $conf "log_line_prefix = '%m [%p] %q%a '\n";
@@ -437,7 +437,7 @@ sub init
 	# TEMP_CONFIG.  Otherwise, print it before TEMP_CONFIG, thereby permitting
 	# overrides.  Settings that merely improve performance or ease debugging
 	# belong before TEMP_CONFIG.
-	print $conf TestLib::slurp_file($ENV{TEMP_CONFIG})
+	print $conf Postgres::Test::Utils::slurp_file($ENV{TEMP_CONFIG})
 	  if defined $ENV{TEMP_CONFIG};
 
 	# XXX Neutralize any stats_temp_directory in TEMP_CONFIG.  Nodes running
@@ -510,7 +510,7 @@ sub append_conf
 
 	my $conffile = $self->data_dir . '/' . $filename;
 
-	TestLib::append_to_file($conffile, $str . "\n");
+	Postgres::Test::Utils::append_to_file($conffile, $str . "\n");
 
 	chmod($self->group_access() ? 0640 : 0600, $conffile)
 	  or die("unable to set permissions for $conffile");
@@ -538,7 +538,7 @@ sub adjust_conf
 
 	my $conffile = $self->data_dir . '/' . $filename;
 
-	my $contents = TestLib::slurp_file($conffile);
+	my $contents = Postgres::Test::Utils::slurp_file($conffile);
 	my @lines    = split(/\n/, $contents);
 	my @result;
 	my $eq = $skip_equals ? '' : '= ';
@@ -587,7 +587,7 @@ sub backup
 	local %ENV = $self->_get_env();
 
 	print "# Taking pg_basebackup $backup_name from node \"$name\"\n";
-	TestLib::system_or_bail(
+	Postgres::Test::Utils::system_or_bail(
 		'pg_basebackup', '-D',
 		$backup_path,    '-h',
 		$self->host,     '-p',
@@ -652,7 +652,7 @@ sub _backup_fs
 		print "# pg_start_backup: $stdout\n";
 	}
 
-	RecursiveCopy::copypath(
+	Postgres::Test::RecursiveCopy::copypath(
 		$self->data_dir,
 		$backup_path,
 		filterfn => sub {
@@ -682,7 +682,7 @@ sub _backup_fs
 =item $node->init_from_backup(root_node, backup_name)
 
 Initialize a node from a backup, which may come from this node or a different
-node. root_node must be a PostgresNode reference, backup_name the string name
+node. root_node must be a Postgres::Test::Cluster reference, backup_name the string name
 of a backup previously created on that node with $node->backup.
 
 Does not start the node after initializing it.
@@ -732,10 +732,10 @@ sub init_from_backup
 	if (defined $params{tar_program})
 	{
 		mkdir($data_path);
-		TestLib::system_or_bail($params{tar_program}, 'xf',
+		Postgres::Test::Utils::system_or_bail($params{tar_program}, 'xf',
 			$backup_path . '/base.tar',
 			'-C', $data_path);
-		TestLib::system_or_bail(
+		Postgres::Test::Utils::system_or_bail(
 			$params{tar_program},         'xf',
 			$backup_path . '/pg_wal.tar', '-C',
 			$data_path . '/pg_wal');
@@ -743,7 +743,7 @@ sub init_from_backup
 	else
 	{
 		rmdir($data_path);
-		RecursiveCopy::copypath($backup_path, $data_path);
+		Postgres::Test::RecursiveCopy::copypath($backup_path, $data_path);
 	}
 	chmod(0700, $data_path);
 
@@ -827,13 +827,13 @@ sub start
 	# sub init) so that it does not get copied to standbys.
 	# -w is now the default but having it here does no harm and helps
 	# compatibility with older versions.
-	$ret = TestLib::system_log('pg_ctl', '-w', '-D', $self->data_dir, '-l',
+	$ret = Postgres::Test::Utils::system_log('pg_ctl', '-w', '-D', $self->data_dir, '-l',
 		$self->logfile, '-o', "--cluster-name=$name", 'start');
 
 	if ($ret != 0)
 	{
 		print "# pg_ctl start failed; logfile:\n";
-		print TestLib::slurp_file($self->logfile);
+		print Postgres::Test::Utils::slurp_file($self->logfile);
 		BAIL_OUT("pg_ctl start failed") unless $params{fail_ok};
 		return 0;
 	}
@@ -865,7 +865,7 @@ sub kill9
 	print "### Killing node \"$name\" using signal 9\n";
 	# kill(9, ...) fails under msys Perl 5.8.8, so fall back on pg_ctl.
 	kill(9, $self->{_pid})
-	  or TestLib::system_or_bail('pg_ctl', 'kill', 'KILL', $self->{_pid});
+	  or Postgres::Test::Utils::system_or_bail('pg_ctl', 'kill', 'KILL', $self->{_pid});
 	$self->{_pid} = undef;
 	return;
 }
@@ -894,7 +894,7 @@ sub stop
 	$mode = 'fast' unless defined $mode;
 	return unless defined $self->{_pid};
 	print "### Stopping node \"$name\" using mode $mode\n";
-	TestLib::system_or_bail('pg_ctl', '-D', $pgdata, '-m', $mode, 'stop');
+	Postgres::Test::Utils::system_or_bail('pg_ctl', '-D', $pgdata, '-m', $mode, 'stop');
 	$self->_update_pid(0);
 	return;
 }
@@ -917,7 +917,7 @@ sub reload
 	local %ENV = $self->_get_env();
 
 	print "### Reloading node \"$name\"\n";
-	TestLib::system_or_bail('pg_ctl', '-D', $pgdata, 'reload');
+	Postgres::Test::Utils::system_or_bail('pg_ctl', '-D', $pgdata, 'reload');
 	return;
 }
 
@@ -943,7 +943,7 @@ sub restart
 
 	# -w is now the default but having it here does no harm and helps
 	# compatibility with older versions.
-	TestLib::system_or_bail('pg_ctl', '-w', '-D', $pgdata, '-l', $logfile,
+	Postgres::Test::Utils::system_or_bail('pg_ctl', '-w', '-D', $pgdata, '-l', $logfile,
 		'restart');
 
 	$self->_update_pid(1);
@@ -969,7 +969,7 @@ sub promote
 	local %ENV = $self->_get_env();
 
 	print "### Promoting node \"$name\"\n";
-	TestLib::system_or_bail('pg_ctl', '-D', $pgdata, '-l', $logfile,
+	Postgres::Test::Utils::system_or_bail('pg_ctl', '-D', $pgdata, '-l', $logfile,
 		'promote');
 	return;
 }
@@ -993,7 +993,7 @@ sub logrotate
 	local %ENV = $self->_get_env();
 
 	print "### Rotating log in node \"$name\"\n";
-	TestLib::system_or_bail('pg_ctl', '-D', $pgdata, '-l', $logfile,
+	Postgres::Test::Utils::system_or_bail('pg_ctl', '-D', $pgdata, '-l', $logfile,
 		'logrotate');
 	return;
 }
@@ -1018,7 +1018,7 @@ primary_conninfo='$root_connstr'
 sub enable_restoring
 {
 	my ($self, $root_node, $standby) = @_;
-	my $path = TestLib::perl2host($root_node->archive_dir);
+	my $path = Postgres::Test::Utils::perl2host($root_node->archive_dir);
 	my $name = $self->name;
 
 	print "### Enabling WAL restore for node \"$name\"\n";
@@ -1029,9 +1029,9 @@ sub enable_restoring
 	# in this routine, using only one back-slash, need to be properly changed
 	# first. Paths also need to be double-quoted to prevent failures where
 	# the path contains spaces.
-	$path =~ s{\\}{\\\\}g if ($TestLib::windows_os);
+	$path =~ s{\\}{\\\\}g if ($Postgres::Test::Utils::windows_os);
 	my $copy_command =
-	  $TestLib::windows_os
+	  $Postgres::Test::Utils::windows_os
 	  ? qq{copy "$path\\\\%f" "%p"}
 	  : qq{cp "$path/%f" "%p"};
 
@@ -1086,7 +1086,7 @@ sub set_standby_mode
 sub enable_archiving
 {
 	my ($self) = @_;
-	my $path   = TestLib::perl2host($self->archive_dir);
+	my $path   = Postgres::Test::Utils::perl2host($self->archive_dir);
 	my $name   = $self->name;
 
 	print "### Enabling WAL archiving for node \"$name\"\n";
@@ -1097,9 +1097,9 @@ sub enable_archiving
 	# in this routine, using only one back-slash, need to be properly changed
 	# first. Paths also need to be double-quoted to prevent failures where
 	# the path contains spaces.
-	$path =~ s{\\}{\\\\}g if ($TestLib::windows_os);
+	$path =~ s{\\}{\\\\}g if ($Postgres::Test::Utils::windows_os);
 	my $copy_command =
-	  $TestLib::windows_os
+	  $Postgres::Test::Utils::windows_os
 	  ? qq{copy "%p" "$path\\\\%f"}
 	  : qq{cp "%p" "$path/%f"};
 
@@ -1141,9 +1141,9 @@ sub _update_pid
 
 =pod
 
-=item PostgresNode->new(node_name, %params)
+=item Postgres::Test::Cluster->new(node_name, %params)
 
-Build a new object of class C<PostgresNode> (or of a subclass, if you have
+Build a new object of class C<Postgres::Test::Cluster> (or of a subclass, if you have
 one), assigning a free port number.  Remembers the node, to prevent its port
 number from being reused for another node, and to ensure that it gets
 shut down when the test script exits.
@@ -1216,11 +1216,11 @@ sub new
 	my $node = {
 		_port    => $port,
 		_host    => $host,
-		_basedir => "$TestLib::tmp_check/t_${testname}_${name}_data",
+		_basedir => "$Postgres::Test::Utils::tmp_check/t_${testname}_${name}_data",
 		_name    => $name,
 		_logfile_generation => 0,
-		_logfile_base       => "$TestLib::log_path/${testname}_${name}",
-		_logfile            => "$TestLib::log_path/${testname}_${name}.log"
+		_logfile_base       => "$Postgres::Test::Utils::log_path/${testname}_${name}",
+		_logfile            => "$Postgres::Test::Utils::log_path/${testname}_${name}.log"
 	};
 
 	if ($params{install_path})
@@ -1242,7 +1242,7 @@ sub new
 
 	my $v = $node->{_pg_version};
 
-	carp("PostgresNode isn't fully compatible with version " . $v)
+	carp("Postgres::Test::Cluster isn't fully compatible with version " . $v)
 	  if $v < 12;
 
 	return $node;
@@ -1285,7 +1285,7 @@ sub _set_pg_version
 	my $version_line = qx{$pg_config --version};
 	BAIL_OUT("$pg_config failed: $!") if $?;
 
-	$self->{_pg_version} = PostgresVersion->new($version_line);
+	$self->{_pg_version} = Postgres::Test::PostgresVersion->new($version_line);
 
 	BAIL_OUT("could not parse pg_config --version output: $version_line")
 	  unless defined $self->{_pg_version};
@@ -1330,7 +1330,7 @@ sub _get_env
 	my $inst = $self->{_install_path};
 	if ($inst)
 	{
-		if ($TestLib::windows_os)
+		if ($Postgres::Test::Utils::windows_os)
 		{
 			# Windows picks up DLLs from the PATH rather than *LD_LIBRARY_PATH
 			# choose the right path separator
@@ -1393,14 +1393,14 @@ Locate an unprivileged (high) TCP port that's not currently bound to
 anything.  This is used by C<new()>, and also by some test cases that need to
 start other, non-Postgres servers.
 
-Ports assigned to existing PostgresNode objects are automatically
+Ports assigned to existing Postgres::Test::Cluster objects are automatically
 excluded, even if those servers are not currently running.
 
 XXX A port available now may become unavailable by the time we start
 the desired service.
 
 Note: this is not an instance method. As it's not exported it should be
-called from outside the module as C<PostgresNode::get_free_port()>.
+called from outside the module as C<Postgres::Test::Cluster::get_free_port()>.
 
 =cut
 
@@ -1439,7 +1439,7 @@ sub get_free_port
 		if ($found == 1)
 		{
 			foreach my $addr (qw(127.0.0.1),
-				($use_tcp && $TestLib::windows_os)
+				($use_tcp && $Postgres::Test::Utils::windows_os)
 				  ? qw(127.0.0.2 127.0.0.3 0.0.0.0)
 				  : ())
 			{
@@ -1473,7 +1473,7 @@ sub can_bind
 
 	# As in postmaster, don't use SO_REUSEADDR on Windows
 	setsockopt(SOCK, SOL_SOCKET, SO_REUSEADDR, pack("l", 1))
-	  unless $TestLib::windows_os;
+	  unless $Postgres::Test::Utils::windows_os;
 	my $ret = bind(SOCK, $paddr) && listen(SOCK, SOMAXCONN);
 	close(SOCK);
 	return $ret;
@@ -1495,7 +1495,7 @@ END
 		next if defined $ENV{'PG_TEST_NOCLEAN'};
 
 		# clean basedir on clean test invocation
-		$node->clean_node if $exit_code == 0 && TestLib::all_tests_passing();
+		$node->clean_node if $exit_code == 0 && Postgres::Test::Utils::all_tests_passing();
 	}
 
 	$? = $exit_code;
@@ -2059,7 +2059,7 @@ sub connect_ok
 	}
 	if (@log_like or @log_unlike)
 	{
-		my $log_contents = TestLib::slurp_file($self->logfile, $log_location);
+		my $log_contents = Postgres::Test::Utils::slurp_file($self->logfile, $log_location);
 
 		while (my $regex = shift @log_like)
 		{
@@ -2129,7 +2129,7 @@ sub connect_fails
 
 	if (@log_like or @log_unlike)
 	{
-		my $log_contents = TestLib::slurp_file($self->logfile, $log_location);
+		my $log_contents = Postgres::Test::Utils::slurp_file($self->logfile, $log_location);
 
 		while (my $regex = shift @log_like)
 		{
@@ -2208,8 +2208,8 @@ $stderr);
 
 =item $node->command_ok(...)
 
-Runs a shell command like TestLib::command_ok, but with PGHOST and PGPORT set
-so that the command will default to connecting to this PostgresNode.
+Runs a shell command like Postgres::Test::Utils::command_ok, but with PGHOST and PGPORT set
+so that the command will default to connecting to this Postgres::Test::Cluster.
 
 =cut
 
@@ -2221,7 +2221,7 @@ sub command_ok
 
 	local %ENV = $self->_get_env();
 
-	TestLib::command_ok(@_);
+	Postgres::Test::Utils::command_ok(@_);
 	return;
 }
 
@@ -2229,7 +2229,7 @@ sub command_ok
 
 =item $node->command_fails(...)
 
-TestLib::command_fails with our connection parameters. See command_ok(...)
+Postgres::Test::Utils::command_fails with our connection parameters. See command_ok(...)
 
 =cut
 
@@ -2241,7 +2241,7 @@ sub command_fails
 
 	local %ENV = $self->_get_env();
 
-	TestLib::command_fails(@_);
+	Postgres::Test::Utils::command_fails(@_);
 	return;
 }
 
@@ -2249,7 +2249,7 @@ sub command_fails
 
 =item $node->command_like(...)
 
-TestLib::command_like with our connection parameters. See command_ok(...)
+Postgres::Test::Utils::command_like with our connection parameters. See command_ok(...)
 
 =cut
 
@@ -2261,7 +2261,7 @@ sub command_like
 
 	local %ENV = $self->_get_env();
 
-	TestLib::command_like(@_);
+	Postgres::Test::Utils::command_like(@_);
 	return;
 }
 
@@ -2269,7 +2269,7 @@ sub command_like
 
 =item $node->command_fails_like(...)
 
-TestLib::command_fails_like with our connection parameters. See command_ok(...)
+Postgres::Test::Utils::command_fails_like with our connection parameters. See command_ok(...)
 
 =cut
 
@@ -2281,7 +2281,7 @@ sub command_fails_like
 
 	local %ENV = $self->_get_env();
 
-	TestLib::command_fails_like(@_);
+	Postgres::Test::Utils::command_fails_like(@_);
 	return;
 }
 
@@ -2289,7 +2289,7 @@ sub command_fails_like
 
 =item $node->command_checks_all(...)
 
-TestLib::command_checks_all with our connection parameters. See
+Postgres::Test::Utils::command_checks_all with our connection parameters. See
 command_ok(...)
 
 =cut
@@ -2302,7 +2302,7 @@ sub command_checks_all
 
 	local %ENV = $self->_get_env();
 
-	TestLib::command_checks_all(@_);
+	Postgres::Test::Utils::command_checks_all(@_);
 	return;
 }
 
@@ -2325,9 +2325,9 @@ sub issues_sql_like
 
 	my $log_location = -s $self->logfile;
 
-	my $result = TestLib::run_log($cmd);
+	my $result = Postgres::Test::Utils::run_log($cmd);
 	ok($result, "@$cmd exit code 0");
-	my $log = TestLib::slurp_file($self->logfile, $log_location);
+	my $log = Postgres::Test::Utils::slurp_file($self->logfile, $log_location);
 	like($log, $expected_sql, "$test_name: SQL found in server log");
 	return;
 }
@@ -2336,8 +2336,8 @@ sub issues_sql_like
 
 =item $node->run_log(...)
 
-Runs a shell command like TestLib::run_log, but with connection parameters set
-so that the command will default to connecting to this PostgresNode.
+Runs a shell command like Postgres::Test::Utils::run_log, but with connection parameters set
+so that the command will default to connecting to this Postgres::Test::Cluster.
 
 =cut
 
@@ -2347,7 +2347,7 @@ sub run_log
 
 	local %ENV = $self->_get_env();
 
-	TestLib::run_log(@_);
+	Postgres::Test::Utils::run_log(@_);
 	return;
 }
 
@@ -2428,8 +2428,8 @@ sub wait_for_catchup
 	  . join(', ', keys(%valid_modes))
 	  unless exists($valid_modes{$mode});
 
-	# Allow passing of a PostgresNode instance as shorthand
-	if (blessed($standby_name) && $standby_name->isa("PostgresNode"))
+	# Allow passing of a Postgres::Test::Cluster instance as shorthand
+	if (blessed($standby_name) && $standby_name->isa("Postgres::Test::Cluster"))
 	{
 		$standby_name = $standby_name->name;
 	}
diff --git a/src/test/perl/PostgresVersion.pm b/src/test/perl/Postgres/Test/PostgresVersion.pm
similarity index 84%
rename from src/test/perl/PostgresVersion.pm
rename to src/test/perl/Postgres/Test/PostgresVersion.pm
index 5ff701ce11..d447b8f05c 100644
--- a/src/test/perl/PostgresVersion.pm
+++ b/src/test/perl/Postgres/Test/PostgresVersion.pm
@@ -1,6 +1,6 @@
 ############################################################################
 #
-# PostgresVersion.pm
+# Postgres::Test::PostgresVersion.pm
 #
 # Module encapsulating Postgres Version numbers
 #
@@ -12,13 +12,13 @@
 
 =head1 NAME
 
-PostgresVersion - class representing PostgreSQL version numbers
+Postgres::Test::PostgresVersion - class representing PostgreSQL version numbers
 
 =head1 SYNOPSIS
 
-  use PostgresVersion;
+  use Postgres::Test::PostgresVersion;
 
-  my $version = PostgresVersion->new($version_arg);
+  my $version = Postgres::Test::PostgresVersion->new($version_arg);
 
   # compare two versions
   my $bool = $version1 <= $version2;
@@ -37,12 +37,12 @@ PostgresVersion - class representing PostgreSQL version numbers
 
 =head1 DESCRIPTION
 
-PostgresVersion encapsulates Postgres version numbers, providing parsing
+Postgres::Test::PostgresVersion encapsulates Postgres version numbers, providing parsing
 of common version formats and comparison operations.
 
 =cut
 
-package PostgresVersion;
+package Postgres::Test::PostgresVersion;
 
 use strict;
 use warnings;
@@ -60,9 +60,9 @@ use overload
 
 =over
 
-=item PostgresVersion->new($version)
+=item Postgres::Test::PostgresVersion->new($version)
 
-Create a new PostgresVersion instance.
+Create a new Postgres::Test::PostgresVersion instance.
 
 The argument can be a number like 12, or a string like '12.2' or the output
 of a Postgres command like `psql --version` or `pg_config --version`;
@@ -103,7 +103,7 @@ sub new
 
 # Routine which compares the _pg_version_array obtained for the two
 # arguments and returns -1, 0, or 1, allowing comparison between two
-# PostgresVersion objects or a PostgresVersion and a version string or number.
+# Postgres::Test::PostgresVersion objects or a Postgres::Test::PostgresVersion and a version string or number.
 #
 # If the second argument is not a blessed object we call the constructor
 # to make one.
diff --git a/src/test/perl/RecursiveCopy.pm b/src/test/perl/Postgres/Test/RecursiveCopy.pm
similarity index 91%
rename from src/test/perl/RecursiveCopy.pm
rename to src/test/perl/Postgres/Test/RecursiveCopy.pm
index 8a9cc722b5..a3f47833c1 100644
--- a/src/test/perl/RecursiveCopy.pm
+++ b/src/test/perl/Postgres/Test/RecursiveCopy.pm
@@ -5,18 +5,18 @@
 
 =head1 NAME
 
-RecursiveCopy - simple recursive copy implementation
+Postgres::Test::RecursiveCopy - simple recursive copy implementation
 
 =head1 SYNOPSIS
 
-use RecursiveCopy;
+use Postgres::Test::RecursiveCopy;
 
-RecursiveCopy::copypath($from, $to, filterfn => sub { return 1; });
-RecursiveCopy::copypath($from, $to);
+Postgres::Test::RecursiveCopy::copypath($from, $to, filterfn => sub { return 1; });
+Postgres::Test::RecursiveCopy::copypath($from, $to);
 
 =cut
 
-package RecursiveCopy;
+package Postgres::Test::RecursiveCopy;
 
 use strict;
 use warnings;
@@ -54,7 +54,7 @@ attempted.
 
 =head1 EXAMPLES
 
- RecursiveCopy::copypath('/some/path', '/empty/dir',
+ Postgres::Test::RecursiveCopy::copypath('/some/path', '/empty/dir',
     filterfn => sub {
 		# omit log/ and contents
 		my $src = shift;
diff --git a/src/test/perl/SimpleTee.pm b/src/test/perl/Postgres/Test/SimpleTee.pm
similarity index 95%
rename from src/test/perl/SimpleTee.pm
rename to src/test/perl/Postgres/Test/SimpleTee.pm
index 681a36a0f8..659c17c6df 100644
--- a/src/test/perl/SimpleTee.pm
+++ b/src/test/perl/Postgres/Test/SimpleTee.pm
@@ -10,7 +10,7 @@
 # method is currently implemented; that's all we need. We don't want to
 # depend on IO::Tee just for this.
 
-package SimpleTee;
+package Postgres::Test::SimpleTee;
 use strict;
 use warnings;
 
diff --git a/src/test/perl/TestLib.pm b/src/test/perl/Postgres/Test/Utils.pm
similarity index 97%
rename from src/test/perl/TestLib.pm
rename to src/test/perl/Postgres/Test/Utils.pm
index cbab1587cc..190fd70ee9 100644
--- a/src/test/perl/TestLib.pm
+++ b/src/test/perl/Postgres/Test/Utils.pm
@@ -5,11 +5,11 @@
 
 =head1 NAME
 
-TestLib - helper module for writing PostgreSQL's C<prove> tests.
+Postgres::Test::Utils - helper module for writing PostgreSQL's C<prove> tests.
 
 =head1 SYNOPSIS
 
-  use TestLib;
+  use Postgres::Test::Utils;
 
   # Test basic output of a command
   program_help_ok('initdb');
@@ -19,19 +19,19 @@ TestLib - helper module for writing PostgreSQL's C<prove> tests.
   # Test option combinations
   command_fails(['initdb', '--invalid-option'],
               'command fails with invalid option');
-  my $tempdir = TestLib::tempdir;
+  my $tempdir = Postgres::Test::Utils::tempdir;
   command_ok('initdb', '-D', $tempdir);
 
   # Miscellanea
-  print "on Windows" if $TestLib::windows_os;
-  my $path = TestLib::perl2host($backup_dir);
+  print "on Windows" if $Postgres::Test::Utils::windows_os;
+  my $path = Postgres::Test::Utils::perl2host($backup_dir);
   ok(check_mode_recursive($stream_dir, 0700, 0600),
     "check stream dir permissions");
-  TestLib::system_log('pg_ctl', 'kill', 'QUIT', $slow_pid);
+  Postgres::Test::Utils::system_log('pg_ctl', 'kill', 'QUIT', $slow_pid);
 
 =head1 DESCRIPTION
 
-C<TestLib> contains a set of routines dedicated to environment setup for
+C<Postgres::Test::Utils> contains a set of routines dedicated to environment setup for
 a PostgreSQL regression test run and includes some low-level routines
 aimed at controlling command execution, logging and test functions.
 
@@ -40,7 +40,7 @@ aimed at controlling command execution, logging and test functions.
 # This module should never depend on any other PostgreSQL regression test
 # modules.
 
-package TestLib;
+package Postgres::Test::Utils;
 
 use strict;
 use warnings;
@@ -56,7 +56,7 @@ use File::Spec;
 use File::stat qw(stat);
 use File::Temp ();
 use IPC::Run;
-use SimpleTee;
+use Postgres::Test::SimpleTee;
 
 # specify a recent enough version of Test::More to support the
 # done_testing() function
@@ -212,9 +212,9 @@ INIT
 	# in the log.
 	my $builder = Test::More->builder;
 	my $fh      = $builder->output;
-	tie *$fh, "SimpleTee", $orig_stdout, $testlog;
+	tie *$fh, "Postgres::Test::SimpleTee", $orig_stdout, $testlog;
 	$fh = $builder->failure_output;
-	tie *$fh, "SimpleTee", $orig_stderr, $testlog;
+	tie *$fh, "Postgres::Test::SimpleTee", $orig_stderr, $testlog;
 
 	# Enable auto-flushing for all the file handles. Stderr and stdout are
 	# redirected to the same file, and buffering causes the lines to appear
diff --git a/src/test/perl/README b/src/test/perl/README
index f04b2a2ea4..1e6e39dd96 100644
--- a/src/test/perl/README
+++ b/src/test/perl/README
@@ -40,15 +40,15 @@ Each test script should begin with:
 
     use strict;
     use warnings;
-    use PostgresNode;
-    use TestLib;
+    use Postgres::Test::Cluster;
+    use Postgres::Test::Utils;
     # Replace with the number of tests to execute:
     use Test::More tests => 1;
 
 then it will generally need to set up one or more nodes, run commands
 against them and evaluate the results. For example:
 
-    my $node = PostgresNode->new('primary');
+    my $node = Postgres::Test::Cluster->new('primary');
     $node->init;
     $node->start;
 
@@ -68,7 +68,7 @@ Read the Test::More documentation for more on how to write tests:
 For available PostgreSQL-specific test methods and some example tests read the
 perldoc for the test modules, e.g.:
 
-    perldoc src/test/perl/PostgresNode.pm
+    perldoc src/test/perl/Postgres::Test::Cluster.pm
 
 Required Perl
 -------------
diff --git a/src/test/recovery/t/001_stream_rep.pl b/src/test/recovery/t/001_stream_rep.pl
index ac581c1c07..20b883ac93 100644
--- a/src/test/recovery/t/001_stream_rep.pl
+++ b/src/test/recovery/t/001_stream_rep.pl
@@ -4,12 +4,12 @@
 # Minimal test testing streaming replication
 use strict;
 use warnings;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More tests => 49;
 
 # Initialize primary node
-my $node_primary = PostgresNode->new('primary');
+my $node_primary = Postgres::Test::Cluster->new('primary');
 # A specific role is created to perform some tests related to replication,
 # and it needs proper authentication configuration.
 $node_primary->init(
@@ -22,7 +22,7 @@ my $backup_name = 'my_backup';
 $node_primary->backup($backup_name);
 
 # Create streaming standby linking to primary
-my $node_standby_1 = PostgresNode->new('standby_1');
+my $node_standby_1 = Postgres::Test::Cluster->new('standby_1');
 $node_standby_1->init_from_backup($node_primary, $backup_name,
 	has_streaming => 1);
 $node_standby_1->start;
@@ -37,7 +37,7 @@ $node_standby_1->backup('my_backup_2');
 $node_primary->start;
 
 # Create second standby node linking to standby 1
-my $node_standby_2 = PostgresNode->new('standby_2');
+my $node_standby_2 = Postgres::Test::Cluster->new('standby_2');
 $node_standby_2->init_from_backup($node_standby_1, $backup_name,
 	has_streaming => 1);
 $node_standby_2->start;
diff --git a/src/test/recovery/t/002_archiving.pl b/src/test/recovery/t/002_archiving.pl
index ce60159f03..757abc4329 100644
--- a/src/test/recovery/t/002_archiving.pl
+++ b/src/test/recovery/t/002_archiving.pl
@@ -4,13 +4,13 @@
 # test for archiving with hot standby
 use strict;
 use warnings;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More tests => 3;
 use File::Copy;
 
 # Initialize primary node, doing archives
-my $node_primary = PostgresNode->new('primary');
+my $node_primary = Postgres::Test::Cluster->new('primary');
 $node_primary->init(
 	has_archiving    => 1,
 	allows_streaming => 1);
@@ -23,7 +23,7 @@ $node_primary->start;
 $node_primary->backup($backup_name);
 
 # Initialize standby node from backup, fetching WAL from archives
-my $node_standby = PostgresNode->new('standby');
+my $node_standby = Postgres::Test::Cluster->new('standby');
 $node_standby->init_from_backup($node_primary, $backup_name,
 	has_restoring => 1);
 $node_standby->append_conf('postgresql.conf',
@@ -62,7 +62,7 @@ is($result, qq(1000), 'check content from archives');
 # promoted.
 $node_standby->promote;
 
-my $node_standby2 = PostgresNode->new('standby2');
+my $node_standby2 = Postgres::Test::Cluster->new('standby2');
 $node_standby2->init_from_backup($node_primary, $backup_name,
 	has_restoring => 1);
 $node_standby2->start;
diff --git a/src/test/recovery/t/003_recovery_targets.pl b/src/test/recovery/t/003_recovery_targets.pl
index 7bd500ed95..d9273f42fc 100644
--- a/src/test/recovery/t/003_recovery_targets.pl
+++ b/src/test/recovery/t/003_recovery_targets.pl
@@ -4,8 +4,8 @@
 # Test for recovery targets: name, timestamp, XID
 use strict;
 use warnings;
-use PostgresNode;
-use TestLib;
+use Postgres::Test::Cluster;
+use Postgres::Test::Utils;
 use Test::More tests => 9;
 use Time::HiRes qw(usleep);
 
@@ -21,7 +21,7 @@ sub test_recovery_standby
 	my $num_rows        = shift;
 	my $until_lsn       = shift;
 
-	my $node_standby = PostgresNode->new($node_name);
+	my $node_standby = Postgres::Test::Cluster->new($node_name);
 	$node_standby->init_from_backup($node_primary, 'my_backup',
 		has_restoring => 1);
 
@@ -50,7 +50,7 @@ sub test_recovery_standby
 }
 
 # Initialize primary node
-my $node_primary = PostgresNode->new('primary');
+my $node_primary = Postgres::Test::Cluster->new('primary');
 $node_primary->init(has_archiving => 1, allows_streaming => 1);
 
 # Bump the transaction ID epoch.  This is useful to stress the portability
@@ -136,7 +136,7 @@ test_recovery_standby('LSN', 'standby_5', $node_primary, \@recovery_params,
 test_recovery_standby('multiple overriding settings',
 	'standby_6', $node_primary, \@recovery_params, "3000", $lsn3);
 
-my $node_standby = PostgresNode->new('standby_7');
+my $node_standby = Postgres::Test::Cluster->new('standby_7');
 $node_standby->init_from_backup($node_primary, 'my_backup',
 	has_restoring => 1);
 $node_standby->append_conf(
@@ -156,7 +156,7 @@ ok($logfile =~ qr/multiple recovery targets specified/,
 
 # Check behavior when recovery ends before target is reached
 
-$node_standby = PostgresNode->new('standby_8');
+$node_standby = Postgres::Test::Cluster->new('standby_8');
 $node_standby->init_from_backup(
 	$node_primary, 'my_backup',
 	has_restoring => 1,
